unit SDEDefs;

interface

uses
  Windows, SysUtils;

const
  EV_Turn_Off = 'Turn Off';
  EV_Turn_On = 'Turn On';
  EV_Restart = 'Restart';
  EV_Log_Off = 'Log Off';
  EV_Lock_Computer = 'Lock Computer';
  EV_Block_Input = 'Block Input';
  EV_Unblock_Input = 'Unblock Input';
  EV_Turn_Off_Monitor = 'Turn Off Monitor';
  EV_Screen_Saver = 'Screen Saver';
  EV_Standby = 'Standby';
  EV_Hibernate = 'Hibernate';
  EV_Wake_Up = 'Wake Up';
  EV_Wake_On_LAN = 'Wake On LAN';
  EV_Start_Application = 'Start_Application';
  EV_Close_Application = 'Close Application';
  EV_Defragmenter = 'Defragmenter';
  EV_Empty_Recycle_Bin = 'Empty Recycle Bin';
  EV_Empty_Clipboard = 'Empty Clipboard';
  EV_Eject_CDROM = 'Eject CD-ROM';
  EV_Close_CDROM = 'Close CD-ROM';
  EV_Capture_Screen = 'Capture Screen';
  EV_Message = 'Message';
  EV_Beep = 'Beep';
  EV_Sound = 'Sound';
  EV_Sound_Off = 'Sound Off';
  EV_Sound_On = 'Sound On';
  EV_Send_Message = 'Send Message';
  EV_Download = 'Download';

  TS_At = 0;
  TS_From_In = 1;
  TS_In = 2;
  TS_Now = 3;
  TS_Daily = 4;
  TS_Business_Days = 5;
  TS_Weekend_Days = 6;
  TS_Weekly = 7;
  TS_Monthly = 8;

  DW_Monday = 1;
  DW_Tuesday = 2;
  DW_Wednesday = 3;
  DW_Thursday = 4;
  DW_Friday = 5;
  DW_Saturday = 6;
  DW_Sunday = 7;

  IP_Local_Host = '';

type
  EventStruct = record
    Event: ShortString;
    Param: ShortString;
    Time_Setting: Integer;
    Time: TDateTime;
    Date: TDateTime;
    DayOfWeek: Integer;
    DayOfMonth: Integer;
    In_Hours: Integer;
    In_Minutes: Integer;
    In_Seconds: Integer;
    Remote_IP: ShortString;
  end;

  PEventStruct = ^EventStruct;

  procedure InitEventStruct(var evStruct: EventStruct);
  function SetEvent(evStruct: EventStruct): Integer;

var
  _SetEvent: function (evStruct: EventStruct): Integer; stdcall = nil;
  _InitEventStruct: procedure (var evStruct: EventStruct); stdcall = nil;

implementation

function LinkAPI(const module, functionname: string): Pointer;
var
  hLib: HMODULE;
begin
  hLib := GetModulehandle(PChar(module));
  if hLib = 0 then
    hLib := LoadLibrary(PChar(module));
  if hLib <> 0 then
    Result := getProcAddress(hLib, PChar(functionname))
  else
    Result := nil;
end;

procedure InitEventStruct(var evStruct: EventStruct);
begin
  if not Assigned(_InitEventStruct) then
    @_InitEventStruct := LinkAPI('SDELib.dll', 'InitEventStruct');
  if Assigned(_InitEventStruct) then
    _InitEventStruct(evStruct);
end;

function SetEvent(evStruct: EventStruct): Integer;
begin
  if not Assigned(_SetEvent) then
    @_SetEvent := LinkAPI('SDELib.dll', 'SetEvent');
  if Assigned(_SetEvent) then
    _SetEvent(evStruct);
end;


end.
