unit SDEController;

{$IFDEF VER220}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER210}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER200}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER190}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER185}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER180}
  {$define DELPHI6UP}
{$endif}

{$IFDEF VER170}
  {$define DELPHI6UP}
{$endif}

{$ifdef VER150}
  {$define DELPHI6UP}
{$endif}

{$ifdef VER140}
  {$define DELPHI6UP}
{$endif}

interface

uses
  SysUtils, Classes, Windows, Messages, Registry, ShellApi, Math;

const
  //Task constants
  TSK_Turn_Off = 'Turn Off';
  TSK_Turn_On = 'Turn On';
  TSK_Restart = 'Restart';
  TSK_Log_Off = 'Log Off';
  TSK_Lock_Computer = 'Lock Computer';
  TSK_Block_Input = 'Block Input';
  TSK_Unblock_Input = 'Unblock Input';
  TSK_Turn_Off_Monitor = 'Turn Off Monitor';
  TSK_Screen_Saver = 'Screen Saver';
  TSK_Standby = 'Standby';
  TSK_Hibernate = 'Hibernate';
  TSK_Wake_Up = 'Wake Up';
  TSK_Wake_On_LAN = 'Wake On LAN';
  TSK_Start_Application = 'Start_Application';
  TSK_Close_Application = 'Close Application';
  TSK_Defragmenter = 'Defragmenter';
  TSK_Empty_Recycle_Bin = 'Empty Recycle Bin';
  TSK_Empty_Clipboard = 'Empty Clipboard';
  TSK_Eject_CDROM = 'Eject CD-ROM';
  TSK_Close_CDROM = 'Close CD-ROM';
  TSK_Capture_Screen = 'Capture Screen';
  TSK_Message = 'Message';
  TSK_Beep = 'Beep';
  TSK_Sound = 'Sound';
  TSK_Sound_Off = 'Sound Off';
  TSK_Sound_On = 'Sound On';
  TSK_Send_Message = 'Send Message';
  TSK_Download = 'Download';
  //////////////////////////////////////////////

  //Time Setting constants
  TS_At = 0;
  TS_From_In = 1;
  TS_In = 2;
  TS_Now = 3;
  TS_Hourly = 4;
  TS_Daily = 5;
  TS_Workdays = 6;
  TS_Weekend_Days = 7;
  TS_Weekly = 8;
  TS_Monthly = 9;
  TS_Yearly = 10; //SDE 5.11 or later
  ////////////////////////

  //Day of week constants for SDE 5.05 or later
  //You can combine them with "or" logical operator for daily tasks
  //Set SDETaskStruct.Period with this value
  DW_Monday = 1;
  DW_Tuesday = 2;
  DW_Wednesday = 4;
  DW_Thursday = 8;
  DW_Friday = 16;
  DW_Saturday = 32;
  DW_Sunday = 64;
  DW_EveryDay = 127; //use it only with daily tasks
  //////////////////////////////////////////////////////////////////

  //Deprecated, use them only for SDE 5.04 or earlier!!!!!!!!!!!!!!!
  DoW_Monday = 1;
  DoW_Tuesday = 2;
  DoW_Wednesday = 3;
  DoW_Thursday = 4;
  DoW_Friday = 5;
  DoW_Saturday = 6;
  DoW_Sunday = 7;
  //////////////////////////////////////////////////////////////////

  IP_Local_Host = '';

  WM_SDETask = WM_APP + 6777;

  regAppPath = 'Software\Zyl Soft\ShutDownExpert\Settings';
  regAppRoot = HKEY_LOCAL_MACHINE;

type
  SDETaskStruct = record
    Task: ShortString;
    Param: ShortString;
    Time_Setting: Integer;
    Time: TDateTime;
    Date: TDateTime;
    DayOfWeek: Integer;
    DayOfMonth: Integer; //deprecated; set to 50
    In_Hours: Integer;
    In_Minutes: Integer;
    In_Seconds: Integer;
    Period: Integer;
    Remote_IP: ShortString;
    Active: Boolean;
  end;

  PSDETaskStruct = ^SDETaskStruct;

  SDEIdleTaskStruct = record
    Task: ShortString;
    Param: ShortString;
    Minutes: Cardinal;
    Active: Boolean;
  end;

  PSDEIdleTaskStruct = ^SDEIdleTaskStruct;

  SDEKeyboardTaskStruct = record
    TaskName: ShortString;
    ApplicationName: ShortString;
    Key: ShortString;
  end;

  PSDEKeyboardTaskStruct = ^SDEKeyboardTaskStruct;

  SDECustomTaskStruct = record
    TaskName: ShortString;
    DllName: ShortString;
    MethodName: ShortString;
  end;

  PSDECustomTaskStruct = ^SDECustomTaskStruct;

  TSDEController = class(TComponent)
  private
    { Private declarations }
    FWindowHandle: HWND;
    FVersion: Double;
    procedure WndProc(var Msg: TMessage);
  protected
    { Protected declarations }
  {$ifdef CLR}
  strict protected
  procedure Finalize; override;
  {$endif}
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure InitSDETaskStruct(var tskStruct: SDETaskStruct);
    function SetSDETask(tskStruct: SDETaskStruct): Integer;
    function RemoveSDETask(TaskId: Integer): Integer;
    function PauseSDETask(TaskId: Integer): Integer;
    function ResumeSDETask(TaskId: Integer): Integer;
    function Unlock(strPassword: AnsiString): Integer;
    function Lock(): Integer;
    function RunSDE(): Integer;
    function IsSDERunning(): Boolean;
    procedure InitSDEIdleTaskStruct(var tskStruct: SDEIdleTaskStruct);
    function SetSDEIdleTask(tskStruct: SDEIdleTaskStruct): Integer;
    function RemoveSDEIdleTask(strTask: AnsiString): Integer;
    function GetSDETaskList: TStringList;
    function IsValidTask(strTask: AnsiString): Boolean;
    function GetSDEIdleTaskList: TStringList;
    function IsValidIdleTask(strTask: AnsiString): Boolean;
    function IsParamRequired(strTask: AnsiString): Boolean;
    function RegisterCustomTask(tskStruct: SDECustomTaskStruct): Integer;
    function UnRegisterCustomTask(strTask: AnsiString): Integer;
    function GetDayOfMonth(day: Integer): Integer;
  published
    { Published declarations }
    property Version: Double read FVersion;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Zyl Soft', [TSDEController]);
end;

constructor TSDEController.Create(AOwner: TComponent);
begin
  inherited;

  FVersion := 1.08;

  {$ifdef DELPHI6UP}
  FWindowHandle := Classes.AllocateHWnd(WndProc);
  {$else}
  FWindowHandle := AllocateHWnd(WndProc);
  {$endif}
end;

destructor TSDEController.Destroy;
begin
  {$ifdef DELPHI6UP}
  Classes.DeallocateHWnd(FWindowHandle);
  {$else}
  DeallocateHWnd(FWindowHandle);
  {$endif}
  inherited Destroy;
end;

procedure TSDEController.WndProc(var Msg: TMessage);
begin
  Msg.Result := DefWindowProc(FWindowHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;

procedure TSDEController.InitSDETaskStruct(var tskStruct: SDETaskStruct);
begin
  tskStruct.Task := '';
  tskStruct.Param := '';
  tskStruct.Time_Setting := 0;
  tskStruct.Time := Time;
  tskStruct.Date := Date;
  tskStruct.DayOfWeek := 1;
  tskStruct.DayOfMonth := 50;
  tskStruct.In_Hours := 0;
  tskStruct.In_Minutes := 0;
  tskStruct.In_Seconds := 0;
  tskStruct.Period := 0;
  tskStruct.Remote_IP := '';
  tskStruct.Active := True;
end;

function TSDEController.SetSDETask(tskStruct: SDETaskStruct): Integer;
var
  lptskStruct: PSDETaskStruct;
  data: TCopyDataStruct;
  wndHandle: HWND;
begin
  if (tskStruct.Time_Setting < TS_At) or (tskStruct.Time_Setting > TS_Yearly) then
  begin
    Result := -2; //invalid time setting
    Exit;
  end;

  if IsParamRequired(tskStruct.Task) and (Trim(tskStruct.Param) = '') then
  begin
    Result := -4; //param missing
    Exit;
  end;

  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    lptskStruct := @tskStruct;
    data.dwData := 0;
    data.cbData:= sizeOf(tskStruct) + 1;
    data.lpData:= lptskStruct;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

function TSDEController.RemoveSDETask(TaskId: Integer): Integer;
var
  wndHandle: HWND;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
    Result := SendMessage(wndHandle, WM_SDETask, 0, TaskId)
  else
    Result := -1;
end;

function TSDEController.PauseSDETask(TaskId: Integer): Integer;
var
  wndHandle: HWND;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
    Result := SendMessage(wndHandle, WM_SDETask, 1, TaskId)
  else
    Result := -1;
end;

function TSDEController.ResumeSDETask(TaskId: Integer): Integer;
var
  wndHandle: HWND;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
    Result := SendMessage(wndHandle, WM_SDETask, 2, TaskId)
  else
    Result := -1;
end;

function TSDEController.Lock: Integer;
var
  wndHandle: HWND;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
    Result := SendMessage(wndHandle, WM_SDETask, 3, 0)
  else
    Result := -1;
end;

function TSDEController.Unlock(strPassword: AnsiString): Integer;
var
  wndHandle: HWND;
  pstrPassword: PChar;
  data: TCopyDataStruct;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    pstrPassword := PChar(strPassword);
    data.dwData := 1;
    data.cbData:= sizeOf(pstrPassword) + 1;
    data.lpData:= pstrPassword;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

function TSDEController.RunSDE: Integer;
var
  reg: TRegistry;
  strPath: AnsiString;
begin
  try
    reg := TRegistry.Create;
    reg.RootKey := regAppRoot;
    reg.OpenKeyReadOnly(regAppPath);
    strPath := reg.ReadString('Path');
    reg.CloseKey;
    reg.Free;
    if FileExists(strPath + 'ShutDown.exe') then
    begin
      Result := 1;
      ShellExecute(FWindowHandle, PChar('open'), PChar(strPath + 'ShutDown.exe'), Nil, Nil, SW_SHOWNORMAL);
      Sleep(200);
    end
    else
    begin
      Result := -1;
    end;
  except
    Result := 0;
  end;
end;

function TSDEController.IsSDERunning: Boolean;
var
  wndHandle: HWND;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  Result := (wndHandle > 0);
end;

function TSDEController.SetSDEIdleTask(
  tskStruct: SDEIdleTaskStruct): Integer;
var
  wndHandle: HWND;
  lptskStruct: PSDEIdleTaskStruct;
  data: TCopyDataStruct;
begin
  if not IsValidIdleTask(tskStruct.Task) then
  begin
    Result := -3; //invalid Task
    Exit;
  end;

  if IsParamRequired(tskStruct.Task) and
     (Trim(tskStruct.Param) = '') then
  begin
    Result := -4; //param missing
    Exit;
  end;

  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    lptskStruct := @tskStruct;
    data.dwData := 2;
    data.cbData:= sizeOf(tskStruct) + 1;
    data.lpData:= lptskStruct;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

function TSDEController.RemoveSDEIdleTask(strTask: AnsiString): Integer;
var
  wndHandle: HWND;
  data: TCopyDataStruct;
  tskStruct: SDEIdleTaskStruct;
  lptskStruct: PSDEIdleTaskStruct;
begin
  if not IsValidIdleTask(strTask) then
  begin
    Result := -3; //invalid Task
    Exit;
  end;

  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    tskStruct.Task := strTask;
    tskStruct.Param := '';
    tskStruct.Minutes := 0;
    tskStruct.Active := False;
    lptskStruct := @tskStruct;
    data.dwData := 2;
    data.cbData:= sizeOf(tskStruct) + 1;
    data.lpData:= lptskStruct;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

procedure TSDEController.InitSDEIdleTaskStruct(
  var tskStruct: SDEIdleTaskStruct);
begin
  tskStruct.Task := '';
  tskStruct.Param := '';
  tskStruct.Minutes := 0;
  tskStruct.Active := False;
end;

function TSDEController.GetSDETaskList: TStringList;
begin
  Result := TStringList.Create();
  Result.Add(TSK_Turn_Off);
  Result.Add(TSK_Turn_On);
  Result.Add(TSK_Restart);
  Result.Add(TSK_Log_Off);
  Result.Add(TSK_Lock_Computer);
  Result.Add(TSK_Block_Input);
  Result.Add(TSK_Unblock_Input);
  Result.Add(TSK_Turn_Off_Monitor);
  Result.Add(TSK_Screen_Saver);
  Result.Add(TSK_Standby);
  Result.Add(TSK_Hibernate);
  Result.Add(TSK_Wake_Up);
  Result.Add(TSK_Wake_On_LAN);
  Result.Add(TSK_Start_Application);
  Result.Add(TSK_Close_Application);
  Result.Add(TSK_Defragmenter);
  Result.Add(TSK_Empty_Recycle_Bin);
  Result.Add(TSK_Empty_Clipboard);
  Result.Add(TSK_Eject_CDROM);
  Result.Add(TSK_Close_CDROM);
  Result.Add(TSK_Capture_Screen);
  Result.Add(TSK_Message);
  Result.Add(TSK_Beep);
  Result.Add(TSK_Sound);
  Result.Add(TSK_Sound_Off);
  Result.Add(TSK_Sound_On);
  Result.Add(TSK_Send_Message);
  Result.Add(TSK_Download);
end;

function TSDEController.GetSDEIdleTaskList: TStringList;
begin
  Result := TStringList.Create();
  Result.Add(TSK_Turn_Off);
  Result.Add(TSK_Restart);
  Result.Add(TSK_Log_Off);
  Result.Add(TSK_Lock_Computer);
  Result.Add(TSK_Block_Input);
  Result.Add(TSK_Unblock_Input);
  Result.Add(TSK_Turn_Off_Monitor);
  Result.Add(TSK_Screen_Saver);
  Result.Add(TSK_Standby);
  Result.Add(TSK_Hibernate);
  Result.Add(TSK_Wake_Up);
  Result.Add(TSK_Wake_On_LAN);
  Result.Add(TSK_Start_Application);
  Result.Add(TSK_Close_Application);
  Result.Add(TSK_Defragmenter);
  Result.Add(TSK_Empty_Recycle_Bin);
  Result.Add(TSK_Empty_Clipboard);
  Result.Add(TSK_Eject_CDROM);
  Result.Add(TSK_Close_CDROM);
  Result.Add(TSK_Capture_Screen);
  Result.Add(TSK_Message);
  Result.Add(TSK_Beep);
  Result.Add(TSK_Sound);
  Result.Add(TSK_Sound_Off);
  Result.Add(TSK_Sound_On);
  Result.Add(TSK_Send_Message);
  Result.Add(TSK_Download);
end;

function TSDEController.IsValidTask(strTask: AnsiString): Boolean;
var
  lst: TStringList;
  i: Integer;
begin
  Result := False;
  lst := GetSDETaskList;
  for i := 0 to lst.Count - 1 do
  begin
    if UpperCase(strTask) = UpperCase(lst[i]) then
    begin
      Result := True;
      break;
    end;
  end;
  lst.Free;
end;

function TSDEController.IsValidIdleTask(strTask: AnsiString): Boolean;
var
  lst: TStringList;
  i: Integer;
begin
  Result := False;
  lst := GetSDEIdleTaskList;
  for i := 0 to lst.Count - 1 do
  begin
    if UpperCase(strTask) = UpperCase(lst[i]) then
    begin
      Result := True;
      break;
    end;
  end;
  lst.Free;
end;

function TSDEController.IsParamRequired(strTask: AnsiString): Boolean;
begin
  if ((UpperCase(strTask) = UpperCase(TSK_Start_Application)) or
     (UpperCase(strTask) = UpperCase(TSK_Close_Application)) or
     (UpperCase(strTask) = UpperCase(TSK_Message)) or
     (UpperCase(strTask) = UpperCase(TSK_Send_Message)) or
     (UpperCase(strTask) = UpperCase(TSK_Download)) or
     (UpperCase(strTask) = UpperCase(TSK_Sound)) or
     (UpperCase(strTask) = UpperCase(TSK_Defragmenter)) or
     (UpperCase(strTask) = UpperCase(TSK_Wake_On_LAN))) then
  begin
    Result := True;
  end
  else
  begin
    Result := False;
  end;
end;

function TSDEController.RegisterCustomTask(
  tskStruct: SDECustomTaskStruct): Integer;
var  
  wndHandle: HWND;
  data: TCopyDataStruct;
  lptskStruct: PSDECustomTaskStruct;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    lptskStruct := @tskStruct;
    data.dwData := 3;
    data.cbData:= sizeOf(tskStruct) + 1;
    data.lpData:= lptskStruct;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

function TSDEController.UnRegisterCustomTask(strTask: AnsiString): Integer;
var
  wndHandle: HWND;
  pstrTask: PChar;
  data: TCopyDataStruct;
begin
  wndHandle := FindWindow(PChar('TfrmShutDown'), nil);
  if wndHandle > 0 then
  begin
    pstrTask := PChar(strTask);
    data.dwData := 4;
    data.cbData:= sizeOf(pstrTask) + 1;
    data.lpData:= pstrTask;
    Result := SendMessage(wndHandle, WM_COPYDATA, FWindowHandle, LongInt(@data));
  end
  else
  begin
    Result := -1; //SDE is not running
  end;
end;

//Day of month constants for SDE 5.10 or later
//You can combine them with "or" logical operator for daily tasks
//Set SDETaskStruct.Period with the return value
function TSDEController.GetDayOfMonth(day: Integer): Integer;
begin
  Result := Round(Power(2, day - 1));
end;

end.
